"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ListApi = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _env = require("@lskjs/env");
var _err = _interopRequireDefault(require("@lskjs/err"));
var _tryJSONparse = _interopRequireDefault(require("@lskjs/utils/tryJSONparse"));
var _forEach = _interopRequireDefault(require("lodash/forEach"));
var _get3 = _interopRequireDefault(require("lodash/get"));
var _mapValues = _interopRequireDefault(require("lodash/mapValues"));
var _pick = _interopRequireDefault(require("lodash/pick"));
var _set = _interopRequireDefault(require("lodash/set"));
var _Api = _interopRequireDefault(require("./Api"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ListApi = /*#__PURE__*/function (_BaseApi) {
  (0, _inherits2["default"])(ListApi, _BaseApi);
  var _super = _createSuper(ListApi);
  function ListApi() {
    (0, _classCallCheck2["default"])(this, ListApi);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(ListApi, [{
    key: "getRoutes",
    value: function getRoutes() {
      return _objectSpread(_objectSpread({}, (0, _get2["default"])((0, _getPrototypeOf2["default"])(ListApi.prototype), "getRoutes", this).call(this)), {}, {
        '/count': this.count.bind(this),
        '/find': this.find.bind(this),
        '/list': this.find.bind(this),
        '/findOne': this.findOne.bind(this),
        '/get': this.findOne.bind(this),
        '/create': this.create.bind(this),
        '/update': this.update.bind(this),
        '/edit': this.update.bind(this),
        '/remove': this.remove.bind(this),
        '/delete': this.remove.bind(this)
      });
    }
  }, {
    key: "cache",
    value: function cache(key, cb) {
      return cb();
    }
  }, {
    key: "getListParams",
    value: function getListParams(req) {
      var data = req.data;
      var params = (0, _mapValues["default"])((0, _pick["default"])(data, ['filter', 'sort', 'skip', 'limit', 'select', 'view', 'operation']), function (a) {
        return (0, _tryJSONparse["default"])(a);
      });
      if (!params.filter) params.filter = {};
      if (req.data) {
        (0, _forEach["default"])(req.data, function (val, key) {
          if (key.substr(0, 'filter.'.length) === 'filter.') {
            (0, _set["default"])(params, key, val);
          }
          if (key.substr(0, 'sort.'.length) === 'sort.') {
            (0, _set["default"])(params, key, val);
          }
        });
      }
      if (params.limit > 100) params.limit = 100;
      if (!params.select) params.select = [];
      if (typeof params.select === 'string') {
        params.select = params.select.trim().split(',').map(function (a) {
          return a.trim();
        });
      }
      if (!Array.isArray(params.select)) throw new _err["default"]('select not array');
      if (!params.view) params.view = 'default';
      // params.operation = req.data.operation;

      return params;
    }
  }, {
    key: "countByParams",
    value: function countByParams(Model) {
      var incomeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var systemParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var params = this.__getParams(Model, incomeParams, systemParams);
      return Model.countDocuments(params.filter);
    }
  }, {
    key: "__getSelect",
    value: function __getSelect(Model) {
      var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var select = (0, _get3["default"])(params, 'select', (0, _get3["default"])(params, 'req.data.select', []));
      var view = (0, _get3["default"])(params, 'view', (0, _get3["default"])(params, 'req.data.view', 'default'));
      if (typeof select === 'string') select = [select];
      var _Model$views = Model.views,
        views = _Model$views === void 0 ? {} : _Model$views;
      return [].concat((0, _toConsumableArray2["default"])(views[view] || []), (0, _toConsumableArray2["default"])(select || []));
    }
  }, {
    key: "__getParams",
    value: function __getParams(Model) {
      var incomeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var systemParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var params = _objectSpread(_objectSpread({}, Model.defaultParams || {}), (0, _pick["default"])(incomeParams, ['filter', 'sort', 'skip', 'limit', 'select', 'view']));
      params.select = this.__getSelect(params);
      if (_env.isDev && (incomeParams.debug || params.select.includes('*'))) {
        delete params.select;
      }
      if (params.limit > 100) {
        console.log('params.limit > 100'); //eslint-disable-line
        params.limit = 100;
      }
      return _objectSpread(_objectSpread({}, params), systemParams);
    }
  }, {
    key: "findByParams",
    value: function findByParams(Model) {
      var incomeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var systemParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var params = this.__getParams(Model, incomeParams, systemParams);
      var res = Model.find(params.filter);
      if (params.sort) {
        res = res.sort(params.sort);
      }
      if (params.skip && +params.skip) {
        res = res.skip(+params.skip);
      }
      if (params.limit && +params.limit) {
        res = res.limit(+params.limit);
      }
      if (params.select) {
        res = res.select(params.select);
      }
      // if (params.then) {
      //   res = params.then(res);
      // }
      // if (params.populate) {
      //   res = res.populate(params.populate);
      // }
      // if (params.prepare) {
      //   return this.prepare(res, params.prepare);
      // }
      return res;
    }
  }, {
    key: "count",
    value: function () {
      var _count = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              throw new _err["default"]('api.notImplemented', {
                status: 500
              });
            case 1:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function count() {
        return _count.apply(this, arguments);
      }
      return count;
    }()
  }, {
    key: "find",
    value: function () {
      var _find = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              throw new _err["default"]('api.notImplemented', {
                status: 500
              });
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }));
      function find() {
        return _find.apply(this, arguments);
      }
      return find;
    }()
  }, {
    key: "findOne",
    value: function () {
      var _findOne = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              throw new _err["default"]('api.notImplemented', {
                status: 500
              });
            case 1:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }));
      function findOne() {
        return _findOne.apply(this, arguments);
      }
      return findOne;
    }()
  }, {
    key: "create",
    value: function () {
      var _create = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              throw new _err["default"]('api.notImplemented', {
                status: 500
              });
            case 1:
            case "end":
              return _context4.stop();
          }
        }, _callee4);
      }));
      function create() {
        return _create.apply(this, arguments);
      }
      return create;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) switch (_context5.prev = _context5.next) {
            case 0:
              throw new _err["default"]('api.notImplemented', {
                status: 500
              });
            case 1:
            case "end":
              return _context5.stop();
          }
        }, _callee5);
      }));
      function update() {
        return _update.apply(this, arguments);
      }
      return update;
    }()
  }, {
    key: "remove",
    value: function () {
      var _remove = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) switch (_context6.prev = _context6.next) {
            case 0:
              throw new _err["default"]('api.notImplemented', {
                status: 500
              });
            case 1:
            case "end":
              return _context6.stop();
          }
        }, _callee6);
      }));
      function remove() {
        return _remove.apply(this, arguments);
      }
      return remove;
    }()
  }]);
  return ListApi;
}(_Api["default"]);
exports.ListApi = ListApi;
var _default = ListApi;
exports["default"] = _default;
//# sourceMappingURL=ListApi.js.map